import RouterViewCom from "@/layout/router-view.vue";
// 不需要菜单管理配置的路由
const staticRouter = [
  {
    path: '/login',
    name: 'fde2b927-2116-43f6-ba5e-94be4abacf39',
    component: () => import('@/views/global/login/login.vue'),
    meta: { title: "登录", icon: "el-icon-location", noAuth: true },
  },
  {
    path:'/find',
    name: '8d7ca281-9f0b-4406-b622-e2525e67c66d',
    component: () => import('@/views/global/findPassword/index.vue'),
    meta: { title: "找回密码", icon: "el-icon-location", noAuth: true },
  },
  {
    path:'/portal',
    name: '455cffd7-6843-4b96-8f4f-57b35bcf5520',
    component: () => import('@/views/global/portal/index.vue'),
    meta: { title: "平台门户", icon: "el-icon-location" }
  },
  {
    path:'/problem',
    name: '8054d0b9-93b5-439c-b7b1-b6c22f1b98d1',
    component: () => import('@/views/global/problem/index.vue'),
    meta: { title: "常见问题", icon: "el-icon-location" }
  },
  {
    path: "/playbackIndex",
    name: "5a244443-04bf-407d-b095-9e999c0b439d",
    component: () => import("@/views/home-management/history/index.vue"),
    meta: { title: "历史回放", icon: "el-icon-location" }
  },
  {
    path: '/weather',
    name: "a68efb11-4774-4988-8598-4b07c6ce13c0",
    component: () => import("@/views/home-management/weather/index.vue"),
    meta: { title: "气象", icon: "el-icon-location" }
  },
  {
    path: "/smart-search",
    component: RouterViewCom,
    name: "fe144048-04a9-4cd2-a66c-c01316305a41",
    meta: { title: "智慧搜索", icon: "el-icon-location" },
    redirect: '/smart-search/index',
    children: [
      {
        path: "index",
        component: () => import('@/views/smart-search/index.vue'),
        name: "8b766a72-186d-4375-b6f4-65cd197f6812",
        meta: { title: "智慧搜索-首页", icon: "el-icon-location" }
      },
      {
        path: "list",
        component: () => import('@/views/smart-search/list.vue'),
        name: "1379c42d-98dd-4f79-be11-042390a2bf83",
        meta: { title: "智慧搜索-查询列表", icon: "el-icon-location" },
      },
      {
        path: "person",
        component: () => import('@/views/smart-search/person/index.vue'),
        name: "3a1cd9fc-ef05-4ca0-975a-e6b074fef381",
        meta: { title: "智慧搜索-人员档案", icon: "el-icon-location" },
      },
      {
        path: "car",
        component: () => import('@/views/smart-search/car/index.vue'),
        name: "d395537f-bdbc-4b89-ad1a-08c822d5585d",
        meta: { title: "智慧搜索-车辆档案", icon: "el-icon-location" },
      },
      {
        path: "ship",
        component: () => import('@/views/smart-search/ship/index.vue'),
        name: "4f795e96-d431-43aa-b672-b68c0defbd4b",
        meta: { title: "智慧搜索-船舶档案", icon: "el-icon-location" },
      }
    ]
  },
]
export default staticRouter
