import * as api from '@/api/index'
import {getUserInfo} from "@/api/modules/global/global";

const state = {
	userInfo: <any>{},
	permissions: [],
}

const getters = {
}

const mutations = {
	SET_USER_INFO(state: any, data: object) {
		state.userInfo = data
	},
	SET_PERMISSIONS(state: any, data: Array<string>) {
		state.permissions = data
	},
}

const actions = {
	LOAD_USER_INFO({ commit }: any, refresh: boolean = false) {
		return new Promise((resolve, reject) => {
			if (refresh || !state.userInfo?.userId) {
				getUserInfo().then((res: any) => {
					if (res.code === 200) {
						commit('SET_USER_INFO', res.user)
						commit('SET_PERMISSIONS', res.permissions)
						resolve(state.userInfo)
					} else {
						reject(res.msg)
					}
				})
			} else {
				resolve(state.userInfo)
			}
		})
	},
}

export default {
	namespaced: true,
	state,
	getters,
	mutations,
	actions
}
